Subject: [PATCH net-next 3/4] selftests: fib_tests: Move admin of dummy0 to helpers

From: David Ahern <[email-masked]>
Date: Tue, 13 Feb 2018 08:37:35 -0800

Move setup and teardown of testns and dummy0 to helpers.

Signed-off-by: David Ahern <[email-masked]>
---
 tools/testing/selftests/net/fib_tests.sh | 100 +++++++++++--------------------
 1 file changed, 34 insertions(+), 66 deletions(-)

diff --git a/tools/testing/selftests/net/fib_tests.sh b/tools/testing/selftests/net/fib_tests.sh
index d4e0b5cb4355..e113cfd659fc 100755
--- a/tools/testing/selftests/net/fib_tests.sh
+++ b/tools/testing/selftests/net/fib_tests.sh
@@ -28,12 +28,24 @@ log_test()
 	fi
 }
 
-netns_create()
+setup()
 {
-	local testns=$1
+	set -e
+	ip netns add testns
+	ip -netns testns link set dev lo up
+
+	ip -netns testns link add dummy0 type dummy
+	ip -netns testns link set dev dummy0 up
+	ip -netns testns address add 198.51.100.1/24 dev dummy0
+	ip -netns testns -6 address add 2001:db8:1::1/64 dev dummy0
+	set +e
+
+}
 
-	ip netns add $testns
-	ip netns exec $testns ip link set dev lo up
+cleanup()
+{
+	ip -netns testns link del dev dummy0 &> /dev/null
+	ip netns del testns
 }
 
 fib_unreg_unicast_test()
@@ -41,14 +53,7 @@ fib_unreg_unicast_test()
 	echo
 	echo "Single path route test"
 
-	set -e
-	netns_create "testns"
-
-	ip -netns testns link add dummy0 type dummy
-	ip -netns testns link set dev dummy0 up
-	ip -netns testns address add 198.51.100.1/24 dev dummy0
-	ip -netns testns -6 address add 2001:db8:1::1/64 dev dummy0
-	set +e
+	setup
 
 	echo "    Start point"
 	ip -netns testns route get fibmatch 198.51.100.2 &> /dev/null
@@ -66,7 +71,7 @@ fib_unreg_unicast_test()
 	ip -netns testns -6 route get fibmatch 2001:db8:1::2 &> /dev/null
 	log_test $? 2 "IPv6 fibmatch - no route"
 
-	ip netns del testns
+	cleanup
 }
 
 fib_unreg_multipath_test()
@@ -75,18 +80,11 @@ fib_unreg_multipath_test()
 	echo
 	echo "Multipath route test"
 
-	set -e
-	netns_create "testns"
-
-	ip -netns testns link add dummy0 type dummy
-	ip -netns testns link set dev dummy0 up
+	setup
 
+	set -e
 	ip -netns testns link add dummy1 type dummy
 	ip -netns testns link set dev dummy1 up
-
-	ip -netns testns address add 198.51.100.1/24 dev dummy0
-	ip -netns testns -6 address add 2001:db8:1::1/64 dev dummy0
-
 	ip -netns testns address add 192.0.2.1/24 dev dummy1
 	ip -netns testns -6 address add 2001:db8:2::1/64 dev dummy1
 
@@ -124,7 +122,7 @@ fib_unreg_multipath_test()
 	ip -netns testns -6 route get fibmatch 2001:db8:3::1 &> /dev/null
 	log_test $? 2 "IPv6 - no route"
 
-	ip netns del testns
+	cleanup
 }
 
 fib_unreg_test()
@@ -138,15 +136,7 @@ fib_down_unicast_test()
 	echo
 	echo "Single path, admin down"
 
-	set -e
-	netns_create "testns"
-
-	ip -netns testns link add dummy0 type dummy
-	ip -netns testns link set dev dummy0 up
-
-	ip -netns testns address add 198.51.100.1/24 dev dummy0
-	ip -netns testns -6 address add 2001:db8:1::1/64 dev dummy0
-	set +e
+	setup
 
 	echo "    Start point"
 	ip -netns testns route get fibmatch 198.51.100.2 &> /dev/null
@@ -164,9 +154,7 @@ fib_down_unicast_test()
 	ip -netns testns -6 route get fibmatch 2001:db8:1::2 &> /dev/null
 	log_test $? 2 "IPv6 fibmatch"
 
-	ip -netns testns link del dev dummy0
-
-	ip netns del testns
+	cleanup
 }
 
 fib_down_multipath_test_do()
@@ -208,18 +196,12 @@ fib_down_multipath_test()
 	echo
 	echo "Admin down multipath"
 
-	set -e
-	netns_create "testns"
-
-	ip -netns testns link add dummy0 type dummy
-	ip -netns testns link set dev dummy0 up
+	setup
 
+	set -e
 	ip -netns testns link add dummy1 type dummy
 	ip -netns testns link set dev dummy1 up
 
-	ip -netns testns address add 198.51.100.1/24 dev dummy0
-	ip -netns testns -6 address add 2001:db8:1::1/64 dev dummy0
-
 	ip -netns testns address add 192.0.2.1/24 dev dummy1
 	ip -netns testns -6 address add 2001:db8:2::1/64 dev dummy1
 
@@ -264,8 +246,7 @@ fib_down_multipath_test()
 	log_test $? 2 "IPv6 fibmatch"
 
 	ip -netns testns link del dev dummy1
-	ip -netns testns link del dev dummy0
-	ip netns del testns
+	cleanup
 }
 
 fib_down_test()
@@ -280,16 +261,10 @@ fib_carrier_local_test()
 	echo
 	echo "Local carrier tests - single path"
 
-	set -e
-	netns_create "testns"
-
-	ip -netns testns link add dummy0 type dummy
-	ip -netns testns link set dev dummy0 up
+	setup
 
+	set -e
 	ip -netns testns link set dev dummy0 carrier on
-
-	ip -netns testns address add 198.51.100.1/24 dev dummy0
-	ip -netns testns -6 address add 2001:db8:1::1/64 dev dummy0
 	set +e
 
 	echo "    Start point"
@@ -340,9 +315,7 @@ fib_carrier_local_test()
 		grep -q "linkdown"
 	log_test $? 1 "IPv6 linkdown flag set"
 
-	ip -netns testns link del dev dummy0
-
-	ip netns del testns
+	cleanup
 }
 
 fib_carrier_unicast_test()
@@ -352,16 +325,10 @@ fib_carrier_unicast_test()
 	echo
 	echo "Single path route carrier test"
 
-	netns_create "testns"
+	setup
 
 	set -e
-	ip -netns testns link add dummy0 type dummy
-	ip -netns testns link set dev dummy0 up
-
 	ip -netns testns link set dev dummy0 carrier on
-
-	ip -netns testns address add 198.51.100.1/24 dev dummy0
-	ip -netns testns -6 address add 2001:db8:1::1/64 dev dummy0
 	set +e
 
 	echo "    Start point"
@@ -412,9 +379,7 @@ fib_carrier_unicast_test()
 		grep -q "linkdown"
 	log_test $? 0 "IPv6 linkdown flag set"
 
-	ip -netns testns link del dev dummy0
-
-	ip netns del testns
+	cleanup
 }
 
 fib_carrier_test()
@@ -446,6 +411,9 @@ if [ $? -ne 0 ]; then
 	exit 0
 fi
 
+# start clean
+cleanup &> /dev/null
+
 fib_test
 
 exit $ret
-- 
2.11.0